HDU 1686 KMP

http://acm.hdu.edu.cn/showproblem.php?pid=1686

The French author Georges Perec (1936–1982) once wrote a book, La disparition, without the letter 'e'. He was a member of the Oulipo group. A quote from the book:

Tout avait Pair normal, mais tout s’affirmait faux. Tout avait Fair normal, d’abord, puis surgissait l’inhumain, l’affolant. Il aurait voulu savoir où s’articulait l’association qui l’unissait au roman : stir son tapis, assaillant à tout instant son imagination, l’intuition d’un tabou, la vision d’un mal obscur, d’un quoi vacant, d’un non-dit : la vision, l’avision d’un oubli commandant tout, où s’abolissait la raison : tout avait l’air normal mais…

Perec would probably have scored high (or rather, low) in the following contest. People are asked to write a perhaps even meaningful text on some subject with as few occurrences of a given “word” as possible. Our task is to provide the jury with a program that counts these occurrences, in order to obtain a ranking of the competitors. These competitors often write very long texts with nonsense meaning; a sequence of 500,000 consecutive 'T's is not unusual. And they never use spaces.

So we want to quickly find out how often a word, i.e., a given string, occurs in a text. More formally: given the alphabet {'A', 'B', 'C', …, 'Z'} and two finite strings over that alphabet, a word W and a text T, count the number of occurrences of W in T. All the consecutive characters of W must exactly match consecutive characters of T. Occurrences may overlap.
 

Input

The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:

One line with the word W, a string over {'A', 'B', 'C', …, 'Z'}, with 1 ≤ |W| ≤ 10,000 (here |W| denotes the length of the string W).
One line with the text T, a string over {'A', 'B', 'C', …, 'Z'}, with |W| ≤ |T| ≤ 1,000,000.

Output

For every test case in the input file, the output should contain a single number, on a single line: the number of occurrences of the word W in the text T.
 

Sample Input

3
BAPC
BAPC
AZA
AZAZAZA
VERDI
AVERDXIVYERDIAN

Sample Output

1
3
0

题目大意: 给出文本串和模式串, 问模式串在文本串中出现了几次。

思路: 依旧是KMP算法, 稍微修改一下就好了。 设i是主串指针, j是模式串指针,当j=len时,++cnt,同时回溯j指针:j=next[j-1],回溯i指针: --i, 即可。为什么这要这样修改呢? 就拿样例的AZAZAZA和AZA来说,AZA分别在位置0、2、4出现, 所以一共出现了3次。 造成这种情况的原因必定是模式串最后几个字符和其最前面的几个字符相同,因此我们让模式串在最后一个位置失配, 并让i自减1。

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#define INF 0x3f3f3f3f
using namespace std;
typedef long long ll;

char s1[1000005];
char s2[10005];
int Next[10005];
int cnt;

void getnext()
{
    int len=strlen(s2);
    Next[0]=-1;
    int j=0,k=-1;
    while(j<len-1)
    {
        if(k==-1||s2[k]==s2[j])
        {
            ++k,++j;
            Next[j]=k;
        }
        else
            k=Next[k];
    }
}

void kmp()
{
    cnt=0;
    int len1=strlen(s1);
    int len2=strlen(s2);
    int i=0,j=0;
    while(i<len1)
    {
        if(j==-1||s1[i]==s2[j])
            ++i,++j;
        else
            j=Next[j];
        if(j==len2)
        {
            ++cnt;
            --i;
            j=Next[j-1];
        }
    }
    printf("%d\n",cnt);
}

int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%s%s",s2,s1);
        getnext();
        kmp();
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/xiji333/article/details/88729704